# -*- Mode: Python -*-
# -*- coding: utf-8 -*-
# vi:si:et:sw=4:sts=4:ts=4

class InterfaceInstaller:

    def __init__(self):
        """
        This function takes no arguments, and solely prepares the installer
        ui to be used and queried (load cache) 
        """

    def is_installed(self, package):
        """
        Check whether a package is installed or not.
        """

    def install(self, package):
        """
        Actual package installation.
        """

from threading import Thread
from codeina.extern.log import log

class InstallerThread (Thread):

    def __init__ (self, installer, provider, done_cb):
        Thread.__init__ (self)
        self.installer = installer
        self.provider = provider
        self.done_cb = done_cb

    def run (self):
        log.log('installer', 'starting the installer thread')
        if 'install_list' in dir (self.installer):
            log.log ('installer', 'installing all products in one time')
            self.installer.install_list (self.provider.products)
        else:
            log.log ('installer', 'installing all products one by one')
            for pkg in self.provider.products:
                self.installer.install (pkg)
        # FIXME return with an other value if the install failes
        log.debug ('installer', 'installation done')
        self.done_cb (0)
